document.addEventListener('DOMContentLoaded', function() {
    loadChatPreview();
    previewChatChangeEvents();

    function previewChatChangeEvents() {
        let header = document.getElementById('adminWhChatHeader');
        let welcome = document.getElementById('adminWhChatWelcome');
        let color = document.getElementById('adminWhThemeColor');
        let buttonText = document.getElementById('adminWhChatButtonText');
        let icons = document.querySelectorAll('input[name="adminWhChatButtonImage"]');
        let sleepChat = document.getElementById('adminWhChatSleep');

        header.addEventListener("change", function () {
            changeChatPreview();
        });
        welcome.addEventListener("change", function () {
            changeChatPreview();
        });
        color.addEventListener("change", function () {
            changeChatPreview();
        });
        buttonText.addEventListener("change", function () {
            changeChatPreview();
        });
        Array.from(icons).forEach(function (position) {
            position.addEventListener("click", function () {
                changeChatPreview();
            });
        });
        sleepChat.addEventListener("input", function () {
            sleepChat.value = sleepChat.value.replace(/\D-/g, '');
        });
        sleepChat.addEventListener("change", function () {
            let sleepError = document.getElementById('adminWhIconSleepError');
            let newValue = sleepChat.value.replace(/\D-/g, '');
            sleepChat.value = newValue;

            sleepError.classList.add('iwp-hide');
            const pattern = /^(-)?\d+$/;

            if (!pattern.test(newValue)) {
                sleepError.classList.remove('iwp-hide');
            }
        });
    }

    function changeChatPreview() {
        let iconsContainer = document.getElementById('adminWhButtonType');

        let header = document.getElementById('adminWhChatHeader');
        let welcome = document.getElementById('adminWhChatWelcome');
        let color = document.getElementById('adminWhThemeColor');
        let buttonText = document.getElementById('adminWhChatButtonText');
        let icon = iconsContainer.querySelector('input[name="adminWhChatButtonImage"]:checked');
        let iconBackgrounds = iconsContainer.querySelectorAll('.iwp-admin-whatsAppChat-icon-background');

        let previewHeader = document.querySelector('.iwp-admin-whatsAppChat-chat-preview-header-text');
        let previewWelcome = document.querySelector('.iwp-admin-whatsAppChat-chat-preview-body-message-box');
        let previewColorHeader = document.querySelector('.iwp-admin-whatsAppChat-chat-preview-header');
        let previewColorBody = document.querySelector('.iwp-admin-whatsAppChat-chat-preview-body');
        let previewColorIcon = document.querySelector('.iwp-admin-whatsAppChat-chat-preview-body-icon');
        let previewButtonText = document.querySelector('.iwp-admin-whatsAppChat-chat-preview-body-text');
        let previewButtonIcon = previewColorIcon.querySelector('img');

        if (header && previewHeader) {
            previewHeader.innerText = header.value;
        }

        if (welcome && previewWelcome) {
            previewWelcome.innerText = welcome.value;
        }

        if (color && previewColorHeader && previewColorBody && previewColorIcon && iconBackgrounds) {
            let bodyColor = hexToRgb(color.value, '0.12');
            previewColorHeader.style.backgroundColor = color.value;
            previewColorBody.style.backgroundColor = bodyColor;
            previewColorIcon.style.backgroundColor = color.value;
            Array.from(iconBackgrounds).forEach(function (iconBackground) {
                iconBackground.style.backgroundColor = color.value;
            });
        }

        if (buttonText && previewButtonText) {
            previewButtonText.innerText = buttonText.value;
        }

        if (icon && previewButtonIcon) {
            previewButtonIcon.src = '';
            previewButtonIcon.classList.add('iwp-hide');
            if (icon.value !== 'none') {
                previewButtonIcon.classList.remove('iwp-hide');
                previewButtonIcon.src = icon.getAttribute('data-img');
            }
        }
    }

    function loadChatPreview() {
        changeChatPreview();
    }

});