<?php
	require_once IWP_PUBLIC_PATH . 'models/iwpWhatsAppChatModel.php';
	$whatsAppChatModel = isset($whatsAppChatModel) ? $whatsAppChatModel : new iwpWhatsAppChatModel();
	if (!$whatsAppChatModel->isEnabled()) {
		return true;
	}
	$icon = $whatsAppChatModel->getIcon();
	$window = $whatsAppChatModel->getWindow();
	$welcome = urlencode($whatsAppChatModel->getWelcomeMessage());
	$whatsAppChatUrl = base64_encode("https://wa.me/{$whatsAppChatModel->getPhone()}?text=$welcome");
	$poweredByLogo = IWP_PUBLIC_URL . 'views/whatsAppChat/images/logo.svg';
	$poweredByLink = 'https://iurny.com';
?>

<div id="iwpPublicWhatsAppChat" class="iwp-public-whatsAppChat <?php echo($icon->getPosition()); ?>">
	<div id="iwpPublicWhatsAppChatIcon" class="iwp-public-whatsAppChat-icon-body <?php echo($icon->getBubble()); ?>"
		 data-sleep="<?php echo($icon->getSleep()); ?>">
		<div class="iwp-public-whatsAppChat-icon-body-message">
			<div class="iwp-public-whatsAppChat-icon-body-message-box"><?php echo($icon->getBubbleText()); ?></div>
		</div>
		<div class="iwp-public-whatsAppChat-icon-body-icon" style="background-color: <?php echo($icon->getColor()); ?>">
			<img src="<?php echo($icon->getImageUrl()); ?>" alt="">
		</div>
	</div>

	<div id="iwpPublicWhatsAppWindow" class="iwp-public-whatsAppChat-chat-container"
		 data-sleep="<?php echo($window->getSleep()); ?>" data-color="<?php echo($window->getColor()); ?>">
		<div class="iwp-public-whatsAppChat-chat-header">
			<div class="iwp-public-whatsAppChat-chat-header-text"><?php echo($window->getHeader()); ?></div>
			<div class="iwp-public-whatsAppChat-chat-header-close">&times;</div>
		</div>
		<div class="iwp-public-whatsAppChat-chat-body">
			<div class="iwp-public-whatsAppChat-chat-body-message">
				<div class="iwp-public-whatsAppChat-chat-body-message-box"><?php echo($window->getBody()); ?></div>
			</div>
			<div class="poweredBy">
				<a href="<?php echo($poweredByLink); ?>" target="_blank">
					<img class="poweredByImg" src="<?php echo($poweredByLogo); ?>" alt="Powered by iurny">
				</a>
			</div>

			<div class="iwp-public-whatsAppChat-chat-body-icon" data-url="<?php echo($whatsAppChatUrl); ?>">
				<div class="iwp-public-whatsAppChat-chat-body-text"><?php echo($window->getButtonText()); ?></div>
				<img src="<?php echo($window->getButtonImage()); ?>" alt="">
			</div>
		</div>
	</div>
</div>
